package com.ruoyi.project.listener.yearSemsApprove;

import com.alibaba.fastjson.JSON;
import com.github.stuxuhai.jpinyin.PinyinFormat;
import com.github.stuxuhai.jpinyin.PinyinHelper;
import com.ruoyi.common.sendEmail.IMailService;
import com.ruoyi.common.utils.SpringContextUtils;
import com.ruoyi.project.sems.domain.TApprove;
import com.ruoyi.project.sems.domain.TReportYlgd;
import com.ruoyi.project.sems.domain.TReportYlrq;
import com.ruoyi.project.sems.service.*;
import com.ruoyi.project.system.service.ISysUserService;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.ExecutionListener;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

@Service("yearEndSucessListener")
public class YearEndSucessListener implements Serializable, ExecutionListener {
    protected Logger logger = LoggerFactory.getLogger(getClass());

    private static final long serialVersionUID = -3759054058055401826L;

    @Override
    public void notify(DelegateExecution delegateExecution) {
        String id = delegateExecution.getProcessInstanceBusinessKey();

        Map variableInstances = delegateExecution.getVariableInstances();
        logger.debug("参数--------------------------------" + JSON.toJSONString(variableInstances));
        logger.debug("审批id--------------------------------" + id);
        ITApproveService tApproveService = (ITApproveService) SpringContextUtils.getBean("tApproveService");
        ITReportYlrqService tReportYlrqService = (ITReportYlrqService) SpringContextUtils.getBean("tReportYlrqService");
        ITReportHiYlrqService tReportHiYlrqService = (ITReportHiYlrqService) SpringContextUtils.getBean("tReportHiYlrqService");
        ITReportYlgdService tReportYlgdService = (ITReportYlgdService) SpringContextUtils.getBean("tReportYlgdService");
        ITReportHiYlgdService tReportHiYlgdService = (ITReportHiYlgdService) SpringContextUtils.getBean("tReportHiYlgdService");
        ISysUserService sysUserService = (ISysUserService) SpringContextUtils.getBean("sysUserService");
        IMailService mailService = (IMailService) SpringContextUtils.getBean("mailService");

        TApprove approveEntity = tApproveService.getById(id);
        approveEntity.setStatus(1l);
        approveEntity.setEndtime(new Date());
        tApproveService.updateById(approveEntity);
        //申请多台设备
        String[] ids = approveEntity.getReportId().split(",");
        switch (approveEntity.getDevType().toString()) {
            case "1":
                for (String i : ids
                ) {
                    TReportYlrq reportYlrqEntity = tReportYlrqService.selectTReportYlrqById(Long.parseLong(i));
                    reportYlrqEntity.setApproveStatus(0l);
                    //更新检查日期
                    reportYlrqEntity.setCheckDate(approveEntity.getCheckDate());
                    tReportYlrqService.updateTReportYlrq(reportYlrqEntity);
                    //审批通过新增历史年度报告数据
                    reportYlrqEntity.setBuildDate(new Date());
                    reportYlrqEntity.setApproveId(approveEntity.getProcessId());
                    reportYlrqEntity.setReportId(Long.parseLong(i));
                    reportYlrqEntity.setYearReportNo(i);
                    tReportHiYlrqService.insertTReportHiYlrq(reportYlrqEntity);
                }
                break;
            case "2":
                for (String i : ids
                ) {
                    TReportYlgd reportYlgdEntity = tReportYlgdService.selectTReportYlgdById(Long.parseLong(i));
                    reportYlgdEntity.setApproveStatus(0l);
                    //更新检查日期
                    reportYlgdEntity.setCheckDate(approveEntity.getCheckDate());
                    tReportYlgdService.updateTReportYlgd(reportYlgdEntity);
                    //审批通过新增历史年度报告数据
                    reportYlgdEntity.setBuildDate(new Date());
                    reportYlgdEntity.setApproveId(approveEntity.getProcessId());
                    reportYlgdEntity.setReportId(Long.parseLong(i));
                    tReportHiYlgdService.insertTReportHiYlgd(reportYlgdEntity);
                }
                break;
        }

        //发送邮件
        try {
            logger.info("user:" + sysUserService.selectUserById(approveEntity.getUserId()));
            String email = sysUserService.selectUserById(approveEntity.getUserId()).getEmail();
            String apNo = approveEntity.getApNo();
            String username = sysUserService.selectUserById(approveEntity.getUserId()).getNickName();
            String usernameEN = PinyinHelper.convertToPinyinString(username, " ", PinyinFormat.WITHOUT_TONE);
            String devType = null;
            String devTypeEN = null;
            switch (approveEntity.getDevType().toString()) {
                case "1":
                    devType = "压力容器";
                    devTypeEN = "Pressure Vessel";
                    break;
                case "2":
                    devType = "压力管道";
                    devTypeEN = "Pressure Pipeline";
                    break;
            }
            String approveType = "生成" + devType + "年度检查报告";
            String approveTypeEN = "Generate annual inspection report of " + devTypeEN;
            //写html开始内容
            String start = "<!DOCTYPE html><html><head><meta charset=\"utf-8\"><title></title></head><body><div style=\"background-color:#ECECEC; padding: 35px;\">" +
                    "<table cellpadding=\"0\" align=\"center\"" +
                    "style=\"width: 600px; margin: 0px auto; text-align: left; position: relative; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 5px; border-bottom-left-radius: 5px; font-size: 14px; font-family:微软雅黑, 黑体; line-height: 1.5; box-shadow: rgb(153, 153, 153) 0px 0px 5px; border-collapse: collapse; background-position: initial initial; background-repeat: initial initial;background:#fff;\">" +
                    "<tbody><tr><th valign=\"middle\" style=\"height: 25px; line-height: 25px; padding: 15px 35px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: #42a3d3; background-color: #49bcff; border-top-left-radius: 5px; border-top-right-radius: 5px; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px;\">" +
                    "<font face=\"微软雅黑\" size=\"5\" style=\"color: rgb(255, 255, 255); \">特种设备信息管理系统 </font><font face=\"微软雅黑\" size=\"3\" style=\"color: rgb(255, 255, 255); \">Special Equipment Management System (SEMS)</font></th></tr>";
            //表html中间内容
            String prime = "";
            String center = "<tr><td><div style=\"padding:25px 35px 40px; background-color:#fff;\"><h2 style=\"margin: 5px 0px; \">" +
                    "<font color=\"#333333\" style=\"line-height: 20px; \"><font style=\"line-height: 22px; \" size=\"4\">" +
                    "亲爱的 username</font><br><font style=\"line-height: 22px; \" size=\"4\">" +
                    "Dear usernameEN</font></font></h2>" +
                    "<p>您的审批已完成：<br>" +
                    "Your approval has been completed:<br>" +
                    "任务编号：<b>apNo</b><br>" +
                    "Task Number: <b>apNoEN</b><br>" +
                    "申请设备类型：<b>devType</b><br>" +
                    "Equipment Type: <b>devTypeEN</b><br>" +
                    "审批类型：<b>approveType</b><br>" +
                    "Application Category: <b>approveTypeEN</b><br>" +
                    "请登录<a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">特种设备信息管理系统</a>查看。<br>" +
                    "Please log in the <a href=\"https://cpms.basf-ypc.net.cn/cpms/index.html#/approve/pending\">SEMS</a> to handle it.</p>" +
                    "<p align=\"right\">date</p>" +
                    "<div style=\"width:700px;margin:0 auto;\">" +
                    "<div style=\"padding:10px 10px 0;border-top:1px solid #ccc;color:#747474;margin-bottom:20px;line-height:1.3em;font-size:12px;\">" +
                    "<p>此为系统邮件，请勿回复<br>This e-Mail is an automatic reminder sent by SEMS, please do not reply</p>" +
                    "</div></div></div></td></tr>";
            String one = center.replaceFirst("username", username);
            String two = one.replaceFirst("usernameEN", usernameEN);
            String three = two.replaceFirst("devType", devType);
            String four = three.replaceFirst("apNo", apNo);
            String five = four.replaceFirst("apNoEN", apNo);
            String six = five.replaceFirst("devTypeEN", devTypeEN);
            String seven = six.replaceFirst("approveType", approveType);
            String eight = seven.replaceFirst("approveTypeEN", approveTypeEN);
            String result = eight.replaceFirst("date", String.valueOf(new Date()));
            prime = prime + result;
            //写html结尾内容
            String end = "</tbody></table></div></body></html>";
            //拼接html
            String html = start + prime + end;
            logger.info("html:" + html);
            mailService.sendHtmlMail(email, "特种设备：您的审批已完成 SEMS:Your approval has been completed (" + apNo + ")", html);
        }catch (Exception e) {
            logger.error("邮件发送失败" + JSON.toJSONString(e));
        }
    }
}
